/* --------------------------------------------------------------  */
/* (C)Copyright 2007,2008,                                         */
/* International Business Machines Corporation                     */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */

#ifndef __INPUT_H__

#define __INPUT_H__

#ifdef PRECISION_D
#define DTYPE double
#else
#define DTYPE float
#endif

#define LOG_ERROR( severity, msg, code) \
        fprintf( stderr, "[%d] %s\n", (code), (msg) )

typedef struct
{
    DTYPE sa ;
    DTYPE *sx ;
    DTYPE *sy ;
    int incx ;
    int incy ;
    int n ;
                                                                                
} input_params1 ;

typedef struct
{
    char uplo ;
    char trans ;
    char diag ;
    int    m;
    int    n;
    DTYPE  alpha;
    DTYPE  beta;
    DTYPE *a, *x, *y, *yOrig, *aOrig ;
    int lda;
    int incX;
    int incY;

} input_params2 ;

typedef struct
{
  char transa ;
  char transb ;
  int m ;
  int n ;
  int k ;
  DTYPE alpha ;
  DTYPE *A ;
  int lda ;
  DTYPE *B ;
  int ldb ;
  DTYPE beta ;
  DTYPE *C ;
  int ldc ;

} input_params3 ;

#endif
