# --------------------------------------------------------------  
# (C)Copyright 2007,2008,                                         
# International Business Machines Corporation                     
# All Rights Reserved.                                            
#                                                                 
# Redistribution and use in source and binary forms, with or      
# without modification, are permitted provided that the           
# following conditions are met:                                   
#                                                                 
# - Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer. 
#                                                                 
# - Redistributions in binary form must reproduce the above       
#   copyright notice, this list of conditions and the following   
#   disclaimer in the documentation and/or other materials        
#   provided with the distribution.                               
#                                                                 
# - Neither the name of IBM Corporation nor the names of its      
#   contributors may be used to endorse or promote products       
#   derived from this software without specific prior written     
#   permission.                                                   
#                                                                 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          
# CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  
# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              
# --------------------------------------------------------------  
# PROLOG END TAG zYx                                              


#!/bin/bash

PROGRAM=./t_thread_blas

#######################################################
# Registering user specified SPE Callbacks
#######################################################

# single thread
$PROGRAM -s 
if [ $? -eq 0 ]; then
echo "3.1 Passed"
else
echo "3.1 Failed"
fi

#multiple threads
env BLAS_NUMSPES_USER=1 $PROGRAM -t 16 -s
if [ $? -eq 0 ]; then
echo "3.2 Passed"
else
echo "3.2 Failed"
fi

env BLAS_NUMSPES_USER=2 $PROGRAM -t 4 -s
if [ $? -eq 0 ]; then
echo "3.3 Passed"
else
echo "3.3 Failed"
fi

# with SPEs launched at numa node 0
env NUMA_NODE_USER=0 BLAS_NUMSPES_USER=2 $PROGRAM -t 3 -s
if [ $? -eq 0 ]; then
echo "3.4 Passed"
else
echo "3.4 Failed"
fi

########################################################
# Registering user specified Memory callbacks
########################################################

#single thread
$PROGRAM -m
if [ $? -eq 0 ]; then
echo "4.1 Passed"
else
echo "4.1 Failed"
fi

#multple threads
env BLAS_NUMSPES_USER=2 $PROGRAM -t 4 -m
if [ $? -eq 0 ]; then
echo "4.2 Passed"
else
echo "4.2 Failed"
fi

##########################################################
#Registering both user specifed SPE and Memory callbacks
##########################################################

#single thread
$PROGRAM -s -m
if [ $? -eq 0 ]; then
echo "4.3 Passed"
else
echo "4.3 Failed"
fi

#multple threads with SPEs launched at numa node 1
env NUMA_NODE_USER=1 BLAS_NUMSPES_USER=1 $PROGRAM -t 8 -s -m
if [ $? -eq 0 ]; then
echo "4.4 Passed"
else
echo "4.4 Failed"
fi
